      REAL FUNCTION alog1p(x)
C     (log1p)
C     Return alog(1 + x), taking care to avoid subtraction loss.
C
C     This version uses an algorithm developed for the HP-15C
C     calculator, mentioned in the log1p implementation in Sun's
C     Freely-Distributable Math Library, FDLIBM:
C
C      * Note: Assuming log() return [sic] accurate answer, the
C      *       following algorithm can be used to compute log1p(x)
C      *       to within a few ULP:
C      *
C      *                u = 1+x;
C      *                if(u==1.0) return x ; else
C      *                           return log(u)*(x/(u-1.0));
C      *
C      *       See HP-15C Advanced Functions Handbook, p.193.
C
C     (22-Jun-2002)
      REAL x, u
      REAL ONE
C
      DATA ONE  / 1.0e+00 /
C
      u = ONE + x
      IF (u .EQ. ONE) THEN
          alog1p = x
      ELSE
          alog1p = alog(u) * (x / (u - ONE))
      END IF
C
      END

      REAL FUNCTION al1p10(x)
C     (log1p10)
C     Return alog10(1 + x), taking care to avoid subtraction loss.
C     (17-Jun-2002)
      REAL x
      REAL alog1p
      REAL LOG10E
C
      DATA LOG10E
     X    /0.43429448190325182765112891891660508229439700580366E+00/
C
      al1p10 = alog1p(x) * LOG10E
C
      END
