      REAL*16 FUNCTION QRAN(K)
C
C     RANDOM NUMBER GENERATOR - BASED ON ALGORITHM 266 BY PIKE AND
C      HILL (MODIFIED BY HANSSON), COMMUNICATIONS OF THE ACM,
C      VOL. 8, NO. 10, OCTOBER 1965.
C
C     THE SINGLE PRECISION VERSION OF THIS SUBPROGRAM IS INTENDED
C     FOR USE ON COMPUTERS WITH FIXED POINT WORDLENGTH OF AT
C     LEAST 29 BITS.  IT IS BEST IF THE FLOATING POINT
C     SIGNIFICAND HAS AT MOST 29 BITS.
C
C     FOLLOWING CODY AND WAITE'S RECOMMENDATION (P. 14), WE
C     PRODUCE A PAIR OF RANDOM NUMBERS AND USE
C
C         RAN1 + 2**(-29)*RAN2 + 2**(-2*29)*RAN3 + 2**(-3*29)
C
C     IN AN ATTEMPT TO GENERATE ABOUT 4*29 = 116 RANDOM BITS, WHICH
C     IS SUFFICIENT FOR THE 113-BIT PRECISION OF 128-BIT IEEE 754
C     AND 96-BIT PRECISION OF 128-BIT IBM S/390 ARITHMETIC.
C
      INTEGER IY,J,K
      DATA             IY     /100001/
      REAL*16          TWOP29, TWOP58, TWOP87
      DATA             TWOP29 / 536870912.0Q+00 /
      DATA             TWOP58 / 288230376151711744.0Q+00 /
      DATA             TWOP87 / 154742504910672534362390528.0Q+00 /
C
      J = K
      IY = IY * 125
      IY = IY - (IY/2796203) * 2796203
      QRAN = QEXT(FLOAT(IY)) / 2796203.0Q+00
C
C     2**29 = 536870912
C
      IY = IY * 125
      IY = IY - (IY/2796203) * 2796203
      QRAN = QRAN + (QEXT(FLOAT(IY)) / 2796203.0Q+00) / TWOP29
C
      IY = IY * 125
      IY = IY - (IY/2796203) * 2796203
      QRAN = QRAN + (QEXT(FLOAT(IY)) / 2796203.0Q+00) / TWOP58
C
      IY = IY * 125
      IY = IY - (IY/2796203) * 2796203
      QRAN = QRAN + (QEXT(FLOAT(IY)) / 2796203.0Q+00) / TWOP87
C
      RETURN
C     ---------- LAST CARD OF QRAN ----------
      END
